﻿using System.ComponentModel;
using System.Configuration.Install;
using System.ServiceProcess;

namespace TestService
{
    /// <summary>
    /// 프로젝트 설치자
    /// </summary>
    [RunInstaller(true)]
    public partial class ProjectInstaller : Installer
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 서비스 프로세스 설치자
        /// </summary>
        private ServiceProcessInstaller serviceProcessInstaller;

        /// <summary>
        /// 서비스 설치자
        /// </summary>
        private ServiceInstaller serviceInstaller;

        /// <summary>
        /// 서비스명
        /// </summary>
        private const string SERVICE_NAME = "TestNode";

        /// <summary>
        /// 서비스 설명
        /// </summary>
        private const string SERVICE_DESCRIPTION = "테스트 노드";

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ProjectInstaller()

        /// <summary>
        /// 생성자
        /// </summary>
        public ProjectInstaller()
        {
            this.serviceProcessInstaller = new ServiceProcessInstaller();

            serviceProcessInstaller.Account = ServiceAccount.LocalSystem;
            serviceProcessInstaller.Password = null;
            serviceProcessInstaller.Username = null;

            this.serviceInstaller = new ServiceInstaller();

            serviceInstaller.ServiceName = SERVICE_NAME;
            serviceInstaller.DisplayName = SERVICE_NAME;
            serviceInstaller.Description = SERVICE_DESCRIPTION;
            serviceInstaller.StartType   = ServiceStartMode.Automatic;

            Installers.AddRange(new Installer[] { this.serviceProcessInstaller, this.serviceInstaller });
        }

        #endregion
    }
}