﻿using System;
using System.ServiceProcess;

using TestLibrary;

namespace TestService
{
    /// <summary>
    /// 프로젝트 서비스
    /// </summary>
    public partial class ProjectService : ServiceBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 에이전트 노드
        /// </summary>
        private TestNode testNode;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ProjectService()

        /// <summary>
        /// 생성자
        /// </summary>
        public ProjectService()
        {
            this.testNode = new TestNode();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 테스트 하기 - Test(argumentArray)

        /// <summary>
        /// 테스트 하기
        /// </summary>
        /// <param name="argumentArray">인자 배열</param>
        public void Test(string[] argumentArray)
        {
            OnStart(argumentArray);

            Console.ReadKey(true);

            OnStop();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 시작시 처리하기 - OnStart(argumentArray)

        /// <summary>
        /// 시작시 처리하기
        /// </summary>
        /// <param name="argumentArray">인자 배열</param>
        protected override void OnStart(string[] argumentArray)
        {
            this.testNode.Start();
        }

        #endregion
        #region 중단시 처리하기 - OnStop()

        /// <summary>
        /// 중단시 처리하기
        /// </summary>
        protected override void OnStop()
        {
            this.testNode.Stop();
        }

        #endregion
    }
}